"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var snipsfile_1 = require("./../../models/snipsfile");
var argparser_1 = require("../../utils/argparser");
var cli_1 = require("../../cli");
var exec_1 = require("../../utils/exec");
exports.command = 'skill [name]';
exports.desc = 'Test a skill';
var head = require('lodash.head');
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var parser, skillName, intentName, slots, message, snipsfile, skill, binding, child;
    return __generator(this, function (_a) {
        parser = new argparser_1.ArgParser(argv);
        skillName = argv.name;
        intentName = parser.getValue('intent');
        slots = parser.getArgd(['intent']);
        if (!skillName || !intentName) {
            message = (!skillName) ? 'No skill name provided.' : 'No intent provided.';
            cli_1.cli.stream.error(chalk_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["", "\nUsage: {blue sam test skill <skillname> intent=<intentname> <slot1name>=<slot1value> ...}\nRun {blue sam test skill help} for additional help."], ["", "\nUsage: {blue sam test skill <skillname> intent=<intentname> <slot1name>=<slot1value> ...}\nRun {blue sam test skill help} for additional help."])), message));
            return [2];
        }
        snipsfile = new snipsfile_1.Snipsfile();
        snipsfile.parse();
        skill = head(snipsfile.skills.filter(function (s) { return s.name === skillName; }));
        if (!skill) {
            cli_1.cli.stream.error(chalk_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["Skill {blue ", "} not found in Snipsfile."], ["Skill {blue ", "} not found in Snipsfile."])), skillName));
            return [2];
        }
        binding = head(skill.bindings.filter(function (b) { return b.intentName === intentName; }));
        if (!binding) {
            cli_1.cli.stream.error(chalk_1.default(templateObject_3 || (templateObject_3 = __makeTemplateObject(["Skill {blue ", "} does not seem to handle intents named {blue ", "}."], ["Skill {blue ", "} does not seem to handle intents named {blue ", "}."])), skillName, intentName));
            return [2];
        }
        cli_1.cli.stream.println(chalk_1.default(templateObject_4 || (templateObject_4 = __makeTemplateObject(["Testing skill {blue ", "} with intent {blue ", "}..."], ["Testing skill {blue ", "} with intent {blue ", "}..."])), skillName, intentName));
        cli_1.cli.stream.println('');
        child = exec_1.Exec.exec(skill.language, binding.action, slots);
        child.stdout.on('data', function (data) {
            cli_1.cli.stream.println('Output:');
            cli_1.cli.stream.println('======================================');
            cli_1.cli.stream.println(data);
            cli_1.cli.stream.println('======================================');
        });
        child.stdout.on('end', function (code) {
            var message = 'Testing complete';
            if (code !== undefined) {
                message += " with exit code " + code;
            }
            cli_1.cli.stream.println(message);
        });
        return [2];
    });
}); };
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
