"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var process = require("process");
var cli_1 = require("../cli");
var config_1 = require("../utils/config");
var ssh_1 = require("../session/ssh");
exports.command = 'connect <HOSTNAME_OR_IP>';
exports.desc = 'Connect to a device';
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var hostname, username, password, response, e_1, onConnected, onSSHCopyId, onCredentialsSaved, ssh, error, initialError;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                hostname = argv['HOSTNAME_OR_IP'];
                username = '';
                password = '';
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4, cli_1.default.prompt.promptQuestions([config_1.Config.usernameQuestion, config_1.Config.passwordQuestion])];
            case 2:
                response = _a.sent();
                username = response['username'];
                password = response['password'];
                return [3, 4];
            case 3:
                e_1 = _a.sent();
                cli_1.default.stream.println();
                cli_1.default.stream.error("Error connecting to device: " + e_1.message, true);
                process.exit();
                return [3, 4];
            case 4:
                if (password.length === 0) {
                    cli_1.default.stream.error('Password cannot be blank');
                    process.exit();
                }
                onConnected = function () {
                    cli_1.default.stream.stopAndClear();
                    cli_1.default.stream.success("Connected to " + hostname, true);
                };
                onSSHCopyId = function () {
                    cli_1.default.stream.hint("A public key has been generated and copied to the device at " + hostname + ":" + ssh_1.snipsRemoteAuthorizedKeysFilename);
                };
                onCredentialsSaved = function () { };
                ssh = new ssh_1.SSHService();
                error = false;
                cli_1.default.stream.loading("Connecting to " + hostname);
                initialError = undefined;
                return [4, ssh.newConnection({ hostname: hostname, username: username }, password, onConnected, onSSHCopyId, onCredentialsSaved).catch(function (e) {
                        error = true;
                        initialError = e.message;
                    })];
            case 5:
                _a.sent();
                if (!error) return [3, 7];
                return [4, ssh.newConnection({ username: username, hostname: hostname + '.local' }, password, onConnected, onSSHCopyId, onCredentialsSaved)
                        .catch(function (e) {
                        cli_1.default.stream.stopAndClear();
                        cli_1.default.stream.println();
                        cli_1.default.stream.error((initialError !== undefined) ? initialError : e.message, true);
                        process.exit();
                    })];
            case 6:
                _a.sent();
                _a.label = 7;
            case 7:
                ssh.disconnect();
                process.exit();
                return [2];
        }
    });
}); };
