"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var process = require("process");
var cli_1 = require("../cli");
var chalk_1 = require("chalk");
var promises_1 = require("../utils/promises");
var rp = require('request-promise');
var fs = require('fs-extra');
exports.command = 'create';
exports.desc = 'Create a new Snips assistant';
var snipsfileSampleLocation = 'https://github.com/snipsco/demo-assistants/raw/master/Snipsfiles/Snipsfile.weather';
var fallbackSnipsfile = "\nassistant_url: https://github.com/snipsco/demo-assistants/raw/master/assistants/weather.zip\nskills:\n  - url: https://github.com/snipsco/snips-skill-owm\n    package_name: snipsowm\n    class_name: SnipsOWM\n    params:\n        default_location: \"Paris, fr\"\n        api_key: a322f5315d6afa31628c1384e389ffc3\n";
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var snipsfile, e_1, e_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cli_1.cli.stream.loading('Creating new Snipsfile...');
                return [4, promises_1.timeout(1000)];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2:
                _a.trys.push([2, 4, , 5]);
                return [4, rp(snipsfileSampleLocation)];
            case 3:
                snipsfile = _a.sent();
                return [3, 5];
            case 4:
                e_1 = _a.sent();
                snipsfile = fallbackSnipsfile;
                return [3, 5];
            case 5:
                _a.trys.push([5, 7, , 8]);
                return [4, fs.outputFile('Snipsfile', snipsfile.trim())];
            case 6:
                _a.sent();
                return [3, 8];
            case 7:
                e_2 = _a.sent();
                cli_1.cli.stream.stopAndClear();
                cli_1.cli.stream.error('Error creating Snipsfile. Make sure you have write access to the current working directory', true);
                process.exit();
                return [3, 8];
            case 8:
                cli_1.cli.stream.done();
                cli_1.cli.stream.loading("Loading sample Snipsfile at " + process.cwd() + "/Snipsfile...");
                return [4, promises_1.timeout(1000)];
            case 9:
                _a.sent();
                cli_1.cli.stream.done();
                cli_1.cli.stream.success('Snipsfile created');
                cli_1.cli.stream.hint("You can now deploy the assistant to your device using " + chalk_1.default.blue('sam deploy'));
                return [2];
        }
    });
}); };
