"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var cli_1 = require("../cli");
var ssh_1 = require("../session/ssh");
var path = require("path");
var chalk_1 = require("chalk");
var snipsfile_1 = require("../models/snipsfile");
exports.command = 'deploy';
exports.desc = 'Deploy the Snipsfile';
exports.builder = {
    snipsfile_path: {
        demandOption: false,
        describe: 'Location of the Snipsfile',
        type: 'string',
        alias: 'sp',
    },
    assistant_path: {
        demandOption: false,
        describe: "Location of the assistant, zip or folder. It's name should be also reflected in the Snipsfile",
        type: 'string',
        alias: 'ap',
    },
    verbose: {
        demandOption: false,
        describe: 'Include remote logs',
        type: 'boolean',
        alias: 'v',
    },
};
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var snipsfilePath, assistantPath, verbose, snipsfile, ssh, consoleUsername, consolePassword, responses, assistant;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                snipsfilePath = JSON.parse(JSON.stringify(argv)).snipsfile_path;
                assistantPath = JSON.parse(JSON.stringify(argv)).assistant_path;
                verbose = JSON.parse(JSON.stringify(argv)).verbose;
                if (snipsfilePath === undefined) {
                    snipsfilePath = path.join(process.cwd(), 'Snipsfile');
                }
                return [4, snipsfile_1.Snipsfile.parse(snipsfilePath)
                        .catch(function (e) {
                        cli_1.cli.stream.done(false);
                        cli_1.cli.stream.errorPlain("Error: Could not locate Snipsfile");
                        process.exit();
                    })];
            case 1:
                snipsfile = _a.sent();
                if (snipsfile === undefined) {
                    cli_1.cli.stream.done(false);
                    cli_1.cli.stream.errorPlain("Error: Could not locate Snipsfile");
                    return [2, process.exit()];
                }
                ssh = new ssh_1.SSHService();
                return [4, ssh.connect()
                        .catch(function (e) {
                        cli_1.cli.stream.error(e);
                        process.exit();
                    })];
            case 2:
                _a.sent();
                if (!(assistantPath !== undefined)) return [3, 4];
                cli_1.cli.stream.loading("Deploying assistant to " + ssh.credentials.hostname + "...");
                return [4, ssh.installAssistant(assistantPath)
                        .catch(function (e) {
                        cli_1.cli.stream.error('Unable to install the assistant:' + e.message);
                        ssh.disconnect();
                        process.exit();
                    })];
            case 3:
                _a.sent();
                cli_1.cli.stream.success();
                _a.label = 4;
            case 4:
                cli_1.cli.stream.loading("Copying Snipsfile to device...");
                return [4, ssh.putFile(snipsfilePath, 'Snipsfile')
                        .catch(function (e) {
                        cli_1.cli.stream.done(false);
                        cli_1.cli.stream.errorPlain("Error deploying assistant: " + e.message);
                        ssh.disconnect();
                        process.exit();
                    })];
            case 5:
                _a.sent();
                cli_1.cli.stream.done();
                consoleUsername = '';
                consolePassword = '';
                if (!(snipsfile.assistantId !== undefined)) return [3, 7];
                return [4, cli_1.cli.prompt.promptQuestions([
                        {
                            name: 'username',
                            type: 'username',
                            message: 'Enter username for the Snips Console:',
                            validate: function (value) {
                                if (value.length) {
                                    return true;
                                }
                                return 'Username cannot be blank';
                            },
                        },
                        {
                            name: 'password',
                            type: 'password',
                            message: 'Enter password for Snips Console:',
                            validate: function (value) {
                                return true;
                            },
                        },
                    ])];
            case 6:
                responses = _a.sent();
                consoleUsername = responses['username'];
                consolePassword = responses['password'];
                _a.label = 7;
            case 7:
                cli_1.cli.stream.loading('Installing dependencies. This may take a few minutes...');
                return [4, ssh.runSnipsmanagerInstall(consoleUsername, consolePassword, function (output) {
                        if (verbose) {
                            cli_1.cli.stream.done();
                            cli_1.cli.stream.println(output);
                        }
                    })];
            case 8:
                _a.sent();
                cli_1.cli.stream.done();
                cli_1.cli.stream.loading('Starting assistant...');
                return [4, ssh.runSnipsManager(function (output) {
                        cli_1.cli.stream.done(true);
                        if (verbose) {
                            cli_1.cli.stream.println(output);
                        }
                    })];
            case 9:
                _a.sent();
                return [4, ssh.getInstalledAssistant()];
            case 10:
                assistant = _a.sent();
                cli_1.cli.stream.done();
                cli_1.cli.stream.println();
                if (assistant !== undefined) {
                    cli_1.cli.stream.success("Snips assistant is now running. Say " + chalk_1.default.blue(assistant.hotword) + " to start!");
                }
                else {
                    cli_1.cli.stream.success("Snips assistant is now running");
                }
                ssh.disconnect();
                process.exit();
                return [2];
        }
    });
}); };
