"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var process = require("process");
var cli_1 = require("../cli");
var ssh_1 = require("../session/ssh");
var device_1 = require("../utils/device");
var chalk_1 = require("chalk");
var shelljs = require("shelljs");
exports.command = 'devices';
exports.desc = 'Discover devices on your local network';
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var devicesIP, ip, broadcastAddress, e_1, devicesIPAndHostname, devicesList;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cli_1.default.stream.loading('Scanning devices on the network...');
                ip = device_1.getLocalExternalIp().split('.');
                ip[ip.length - 1] = '255';
                broadcastAddress = ip.join('.');
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4, shelljs.exec("ping " + broadcastAddress + " -c 2", { async: true, silent: true })];
            case 2:
                _a.sent();
                return [3, 4];
            case 3:
                e_1 = _a.sent();
                cli_1.default.stream.stop();
                cli_1.default.stream.error("Broadcasting ping failed on " + broadcastAddress + ", some devices may not appear");
                return [3, 4];
            case 4: return [4, device_1.scanNetwork()
                    .catch(function (e) {
                    cli_1.default.stream.stop();
                    cli_1.default.stream.error('Error scanning network: ' + e.message);
                    process.exit();
                })];
            case 5:
                devicesIP = _a.sent();
                if (devicesIP === undefined) {
                    cli_1.default.stream.stop();
                    cli_1.default.stream.error('No devices found');
                    return [2, process.exit()];
                }
                return [4, ssh_1.SSHService.fetchBootHostname(devicesIP)
                        .catch(function (e) {
                        cli_1.default.stream.stop();
                        cli_1.default.stream.error(e);
                    })];
            case 6:
                devicesIPAndHostname = _a.sent();
                if (devicesIPAndHostname === undefined) {
                    cli_1.default.stream.stop();
                    cli_1.default.stream.error('Error fetching device hostnames');
                    return [2, process.exit()];
                }
                devicesList = devicesIPAndHostname.map(function (_a) {
                    var ip = _a.ip, hostname = _a.hostname, snipsHostname = _a.snipsHostname;
                    if (snipsHostname.length > 0) {
                        if (hostname.length === 0) {
                            return "- " + ip + ", alias: " + snipsHostname;
                        }
                        return "- " + hostname + " (" + ip + ", alias: " + snipsHostname + ")";
                    }
                    if (hostname.length === 0) {
                        return "- " + ip;
                    }
                    return "- " + hostname + " (" + ip + ")";
                });
                cli_1.default.stream.stopAndClear();
                cli_1.default.stream.println("");
                if (devicesList.length === 1) {
                    cli_1.default.stream.println("Found 1 device:");
                }
                else {
                    cli_1.default.stream.println("Found " + devicesList.length + " devices:\n");
                }
                devicesList.forEach(function (device) {
                    cli_1.default.stream.println(device);
                });
                cli_1.default.stream.println('\nConnect to a device using ' + chalk_1.default.blue('sam connect HOSTNAME_OR_IP'));
                process.exit();
                return [2];
        }
    });
}); };
