"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var cli_1 = require("../../cli");
var ssh_1 = require("../../session/ssh");
var promises_1 = require("../../utils/promises");
exports.command = 'audio';
exports.desc = 'Quickly setup the mic & speaker on your device';
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var ssh, respeaker, respeakerbis, isConnected_1, numberOfRetries_1, captureDevice, captureDevices, response_1, e_1, outputDevice, outputDevices, response_2, e_2, e_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                ssh = new ssh_1.SSHService();
                return [4, ssh.connect()
                        .catch(function (e) {
                        cli_1.cli.stream.error(e);
                        process.exit();
                    })];
            case 1:
                _a.sent();
                return [4, cli_1.cli.prompt.promptQuestions([
                        {
                            name: 'respeaker',
                            type: 'confirm',
                            message: 'Do you have a Respeaker mic hat (2mic or 4mic) ?',
                            default: false,
                        },
                    ])];
            case 2:
                respeaker = _a.sent();
                if (!(respeaker['respeaker'] === true)) return [3, 8];
                return [4, cli_1.cli.prompt.promptQuestions([
                        {
                            name: 'installation',
                            type: 'confirm',
                            message: "Do you want to install the Respeaker's drivers ?",
                            default: false,
                        },
                    ])];
            case 3:
                respeakerbis = _a.sent();
                if (!(respeakerbis['installation'] === true)) return [3, 8];
                return [4, ssh.installRespeakerMicHat(function (output) { return cli_1.cli.stream.print(output); })
                        .catch(function (e) { return cli_1.cli.stream.error(e); })];
            case 4:
                _a.sent();
                isConnected_1 = false;
                numberOfRetries_1 = 0;
                _a.label = 5;
            case 5:
                if (!(isConnected_1 === false)) return [3, 8];
                cli_1.cli.stream.loading('Waiting for device to reboot');
                return [4, promises_1.timeout(10000)];
            case 6:
                _a.sent();
                cli_1.cli.stream.done(true);
                cli_1.cli.stream.loading('Trying to reconnect');
                return [4, ssh.connect()
                        .then(function (r) {
                        isConnected_1 = true;
                        cli_1.cli.stream.success();
                    })
                        .catch(function (e) {
                        if (numberOfRetries_1 < 3) {
                            cli_1.cli.stream.done(false);
                            cli_1.cli.stream.error('Failed to connect. Retrying in 10s');
                        }
                        else {
                            cli_1.cli.stream.done(false);
                            cli_1.cli.stream.error('Failed to connect 3 times, exiting');
                            process.exit();
                        }
                    })];
            case 7:
                _a.sent();
                numberOfRetries_1 += 1;
                return [3, 5];
            case 8:
                _a.trys.push([8, 13, , 14]);
                return [4, ssh.listCaptureDevices()];
            case 9:
                captureDevices = _a.sent();
                if (!(captureDevices.length === 1)) return [3, 10];
                cli_1.cli.stream.success("Found only 1 capture device named: " + captureDevices[0].name);
                cli_1.cli.stream.println("We will use this device to capture sound");
                captureDevice = captureDevices[0];
                return [3, 12];
            case 10: return [4, cli_1.cli.prompt.promptList('device', "We found " + captureDevices.length + " interfaces to record sound.\n  Choose the one you want to use", captureDevices.map(function (device) { return device.name; }))];
            case 11:
                response_1 = _a.sent();
                captureDevice = captureDevices.find(function (device) { return device.name === response_1['device']; });
                _a.label = 12;
            case 12: return [3, 14];
            case 13:
                e_1 = _a.sent();
                cli_1.cli.stream.error('Error fetching audio capture device: ' + e_1.message);
                return [3, 14];
            case 14:
                if (captureDevice === undefined) {
                    cli_1.cli.stream.hint('Using default capture configuration card 1 subdevice 0');
                    captureDevice = { name: 'Default', card: 1, subdevice: 0 };
                }
                _a.label = 15;
            case 15:
                _a.trys.push([15, 20, , 21]);
                return [4, ssh.listOuputDevices()];
            case 16:
                outputDevices = _a.sent();
                if (!(outputDevices.length === 1)) return [3, 17];
                cli_1.cli.stream.success("Found only 1 output device named: " + outputDevices[0].name);
                cli_1.cli.stream.println("We will use this device to output sound");
                outputDevice = outputDevices[0];
                return [3, 19];
            case 17: return [4, cli_1.cli.prompt.promptList('device', "We found " + outputDevices.length + " interfaces to output sound.\n  Choose the one you want to use as your speaker", outputDevices.map(function (device) { return device.name; }))];
            case 18:
                response_2 = _a.sent();
                outputDevice = outputDevices.find(function (device) { return device.name === response_2['device']; });
                _a.label = 19;
            case 19: return [3, 21];
            case 20:
                e_2 = _a.sent();
                cli_1.cli.stream.error('Error fetching audio output device: ' + e_2.message);
                return [3, 21];
            case 21:
                if (outputDevice === undefined) {
                    cli_1.cli.stream.error("An output device wasn't found");
                    return [2];
                }
                _a.label = 22;
            case 22:
                _a.trys.push([22, 24, , 25]);
                return [4, ssh.setupAsoundConf(outputDevice, captureDevice)];
            case 23:
                _a.sent();
                cli_1.cli.stream.success('Installed /etc/asound.conf');
                return [3, 25];
            case 24:
                e_3 = _a.sent();
                cli_1.cli.stream.error('Error installing the microphone asound.conf: ' + e_3.message);
                ssh.disconnect();
                process.exit();
                return [3, 25];
            case 25: return [4, ssh.setVolumeLevel(outputDevice.card, 90)
                    .catch(function (failure) { })];
            case 26:
                _a.sent();
                cli_1.cli.stream.success('Set the output level at 80%');
                return [4, ssh.setCaptureLevel(captureDevice.card, 80)
                        .catch(function (failure) { })];
            case 27:
                _a.sent();
                cli_1.cli.stream.success('Set the capture level at 90%');
                cli_1.cli.stream.hint(chalk_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["You can test your microphone & speaker with {blue sam test microphone / speaker}"], ["You can test your microphone & speaker with {blue sam test microphone / speaker}"]))));
                ssh.disconnect();
                return [2];
        }
    });
}); };
var templateObject_1;
