"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var cli_1 = require("../cli");
var ssh_1 = require("../session/ssh");
var strings_1 = require("../utils/strings");
var errors_1 = require("../utils/errors");
exports.command = 'status';
exports.desc = 'Show the status of your device';
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var ssh, servicesStatus, packagesVersion, isSnipsInstalled, assistant, isAssistantInstalled, isAnySnipsServiceLive, deviceName, osVersion, assistantStatus, statusString, tabSize, statusText;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cli_1.cli.stream.loading('Fetching device status...');
                ssh = new ssh_1.SSHService();
                return [4, ssh.connect().catch(function (e) {
                        cli_1.cli.stream.stopAndClear();
                        if (e.name === errors_1.NO_CREDENTIALS_FOUND) {
                            cli_1.cli.stream.println();
                            cli_1.cli.stream.println("You are not connected to any device");
                            cli_1.cli.stream.println();
                            cli_1.cli.stream.println("To connect to a device, run " + chalk_1.default.blue('sam connect HOSTNAME_OR_IP'));
                            cli_1.cli.stream.println("To list devices on the network, run " + chalk_1.default.blue('sam devices'));
                        }
                        else if (e.name === errors_1.SSH_CONNECT_ERROR) {
                            cli_1.cli.stream.println();
                            if (ssh.credentials.hostname !== undefined && ssh.credentials.hostname !== '') {
                                cli_1.cli.stream.error("Could not establish connection to " + ssh.credentials.hostname + ": " + e.message, true);
                            }
                            else {
                                cli_1.cli.stream.error("Could not establish connection to device: " + e.message, true);
                            }
                        }
                        else {
                            cli_1.cli.stream.println();
                            cli_1.cli.stream.error(e.message);
                        }
                        ssh.disconnect();
                        process.exit();
                    })];
            case 1:
                _a.sent();
                return [4, ssh.snipsServicesSystemctlStatus().catch(function (e) { })];
            case 2:
                servicesStatus = _a.sent();
                return [4, ssh.packagesVersion().catch(function (e) { })];
            case 3:
                packagesVersion = _a.sent();
                isSnipsInstalled = (packagesVersion !== undefined && packagesVersion.length > 0);
                return [4, ssh.getInstalledAssistant()];
            case 4:
                assistant = _a.sent();
                isAssistantInstalled = assistant !== undefined;
                isAnySnipsServiceLive = false;
                if (servicesStatus !== undefined) {
                    servicesStatus.forEach(function (serviceStatus) { if (serviceStatus.active) {
                        isAnySnipsServiceLive = true;
                    } });
                }
                deviceName = ssh.credentials.hostname;
                return [4, ssh.getOSVersion()];
            case 5:
                osVersion = _a.sent();
                assistantStatus = (assistant === undefined) ? 'Not installed' : assistant.name;
                cli_1.cli.stream.stopAndClear();
                if (!isSnipsInstalled) {
                    statusString = chalk_1.default.red('Snips Platform not installed');
                }
                else if (!isAnySnipsServiceLive) {
                    if (isAssistantInstalled) {
                        statusString = chalk_1.default.yellow('Idle');
                    }
                    else {
                        statusString = chalk_1.default.yellow('Idle') + " (no assistant)";
                    }
                }
                else if (!isAssistantInstalled) {
                    statusString = chalk_1.default.green('Live') + " (no assistant)";
                }
                else {
                    statusString = chalk_1.default.green('Live');
                }
                tabSize = 30;
                statusText = chalk_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\nConnected to device {blue ", "}\n\n"], ["\\nConnected to device {blue ", "}\\n\\n"])), deviceName);
                statusText += strings_1.fill('OS version', tabSize) + " " + osVersion + "\n";
                if (isSnipsInstalled) {
                    statusText += strings_1.fill('Installed assistant', tabSize) + " " + assistantStatus + "\n";
                    if (isAssistantInstalled && assistant !== undefined) {
                        statusText += strings_1.fill('Language', tabSize) + " " + assistant.language + "\n";
                        statusText += strings_1.fill('Hotword', tabSize) + " " + assistant.hotword + "\n";
                        statusText += strings_1.fill('ASR engine', tabSize) + " " + assistant.asrType + "\n";
                    }
                }
                statusText += strings_1.fill('Status', tabSize) + " " + statusString;
                if (isSnipsInstalled && servicesStatus !== undefined) {
                    statusText += "\n\nService status:\n\n";
                    servicesStatus.forEach(function (serviceStatus) {
                        var version = getPackageVersion(packagesVersion, serviceStatus.name);
                        var versionString = (version !== undefined) ? version + ' ' : '';
                        statusText += strings_1.fill(serviceStatus.name, tabSize) + " " + versionString + (serviceStatus.active ? chalk_1.default.green('(running)') : chalk_1.default.red('(not running)')) + "\n";
                    });
                }
                cli_1.cli.stream.println(statusText);
                if (!isSnipsInstalled) {
                    cli_1.cli.stream.println("\nYou may install the Snips Platform using " + chalk_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["{blue sam init}"], ["{blue sam init}"]))) + "\nTo install specific components, check the help using " + chalk_1.default(templateObject_3 || (templateObject_3 = __makeTemplateObject(["{blue sam init --help}"], ["{blue sam init --help}"]))));
                }
                ssh.disconnect();
                process.exit();
                return [2];
        }
    });
}); };
var getPackageVersion = function (packageVersions, packageName) {
    if (packageVersions === undefined) {
        return undefined;
    }
    var version = undefined;
    packageVersions.forEach(function (packageVersion) {
        if (packageVersion.name === packageName) {
            version = packageVersion.version;
        }
    });
    return version;
};
var templateObject_1, templateObject_2, templateObject_3;
