"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var cli_1 = require("../../cli");
var ssh_1 = require("../../session/ssh");
exports.command = 'microphone';
exports.desc = 'Test a microphone';
exports.handler = function (argv) { return __awaiter(_this, void 0, void 0, function () {
    var _this = this;
    var ssh, recordingFile, e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                ssh = new ssh_1.SSHService();
                return [4, ssh.connect()
                        .catch(function (e) {
                        cli_1.cli.stream.error(e);
                        process.exit();
                    })];
            case 1:
                _a.sent();
                cli_1.cli.stream.hint('Plug in your microphone and turn on your speaker');
                _a.label = 2;
            case 2:
                _a.trys.push([2, 5, , 6]);
                recordingFile = 'sam_recording';
                cli_1.cli.prompt.waitForKeypress('Say something in the microphone, then press a key to continue...', function () { return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                cli_1.cli.stream.success();
                                return [4, ssh.stopRecording().catch(function (e) { })];
                            case 1:
                                _a.sent();
                                return [2];
                        }
                    });
                }); });
                return [4, ssh.recordAudio(recordingFile).catch(function (e) { })];
            case 3:
                _a.sent();
                cli_1.cli.stream.loading('Playing the recording');
                return [4, ssh.playAudio(recordingFile).catch(function (e) { })];
            case 4:
                _a.sent();
                cli_1.cli.stream.success();
                return [3, 6];
            case 5:
                e_1 = _a.sent();
                cli_1.cli.stream.stopAndClear();
                cli_1.cli.stream.error('Error testing the microphone: ' + e_1.message);
                ssh.disconnect();
                process.exit();
                return [3, 6];
            case 6:
                cli_1.cli.stream.hint("Didn't hear anything? Check the recording level of your microphone and the volume of the speaker.");
                cli_1.cli.stream.hint("Alternatively you can run " + chalk_1.default.blue('sam setup audio') + ' to setup your microphone');
                ssh.disconnect();
                process.exit();
                return [2];
        }
    });
}); };
