import { CLI } from '../../cli';
export declare class BisectionResult {
    minActive: number;
    maxActive: number;
    asrResults: ASRResult[];
}
export declare class ASRResult {
    assistant: string;
    rtfs: number[][];
    max: number;
    min: number;
    mean: number;
    variance: number;
    std: number;
    constructor(assistant: string);
    processRTFs(): void;
}
export interface WAVFile {
    path: string;
    duration: number;
    name: string;
}
export declare class ASRBenchmark {
    private ssh;
    private remoteAudioPath;
    private rtfResultPromise;
    private cli;
    constructor(cli: CLI);
    connect: () => Promise<void>;
    reset: () => Promise<void>;
    setupServicesOnDevice: () => Promise<string>;
    deployAssistant: (assistantPath: string) => Promise<void>;
    deployWAVFolder: (wavFolderPath: string) => Promise<void>;
    bisection: (assistantName: string, wavFiles: WAVFile[], minActive: number, maxActive: number, stdReference: number, stepSize: number, benchmarkPasses: number) => Promise<void>;
    getWAVFileFromPathAndCheckValidity: (wavFilePath: string) => Promise<WAVFile[]>;
    setupASRService: (maxActive: number, minActive: number) => Promise<void>;
    launchBenchmark: (assistantName: string, wavFiles: WAVFile[]) => Promise<number[]>;
    private playRemoteWAV;
    private journalctlLogListener;
    private extractRTFfromEndpointingLog(log);
    private getWAVDuration;
}
