"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var binding_1 = require("./binding");
var language_1 = require("./language");
var Skill = (function () {
    function Skill(yamlDoc, defaultLang) {
        if (defaultLang === void 0) { defaultLang = language_1.SkillLang.PYTHON; }
        this.name = yamlDoc.name;
        this.url = yamlDoc.url;
        this.language = language_1.langFromString(yamlDoc.language, defaultLang);
        if (yamlDoc.intents) {
            this.bindings = yamlDoc.intents.map(function (intent) { return new binding_1.Binding(intent); });
        }
        else {
            this.bindings = [];
        }
    }
    return Skill;
}());
exports.Skill = Skill;
