"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fsExtra = require("fs-extra");
var nodeSsh = require("node-ssh");
var os = require("os");
var path = require("path");
var shelljs = require("shelljs");
var audiodevice_1 = require("../utils/audiodevice");
var assistant_1 = require("../models/assistant");
var config_1 = require("../utils/config");
var errors_1 = require("../utils/errors");
exports.snipsRemoteAuthorizedKeysFilename = '~/.ssh/authorized_keys';
var snipsRSAKeyName = 'id_rsa_snips';
var snipsRSAKeyFilePath = path.join(os.homedir(), '.ssh', snipsRSAKeyName);
exports.availableSnipsServices = ['snips-hotword', 'snips-queries', 'snips-analytics', 'snips-dialogue', 'snips-asr', 'snips-tts', 'snips-audio-server', 'snipsmanager'];
var SSHService = (function () {
    function SSHService() {
        var _this = this;
        this.connect = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var credentials;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, config_1.Config.getCredentials()
                            .catch(function (e) { errors_1.newError("No credentials found", errors_1.NO_CREDENTIALS_FOUND); })];
                    case 1:
                        credentials = _a.sent();
                        if (credentials === undefined) {
                            throw errors_1.newError("No credentials found", errors_1.NO_CREDENTIALS_FOUND);
                        }
                        return [2, this.connectInternal(credentials)
                                .catch(function (e) {
                                _this.disconnect();
                                throw errors_1.newError(e.message, errors_1.SSH_CONNECT_ERROR);
                            })];
                }
            });
        }); };
        this.newConnection = function (credentials, password, onConnected, onSSHCopyId, onCredentialsSaved) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.connectInternal(credentials, password)
                            .then(function (success) { return onConnected(); })
                            .catch(function (e) {
                            throw new Error("Error connecting to " + credentials.hostname + ": " + e.message);
                        })];
                    case 1:
                        _a.sent();
                        return [4, this.sshCopyId(credentials.hostname, credentials.username)
                                .then(function (s) { return onSSHCopyId(); })
                                .catch(function (e) {
                                _this.disconnect();
                                throw new Error("Failed to copy SSH public key: " + e.message);
                            })];
                    case 2:
                        _a.sent();
                        return [4, config_1.Config.deleteCredentials().catch(function (e) { })];
                    case 3:
                        _a.sent();
                        return [4, config_1.Config.saveCredentialsOnDisk(credentials)
                                .then(function (s) { return onCredentialsSaved(); })
                                .catch(function (e) {
                                _this.disconnect();
                                throw new Error("Failed to save credentials: " + e.message);
                            })];
                    case 4:
                        _a.sent();
                        return [2];
                }
            });
        }); };
        this.connectInternal = function (credentials, password) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.credentials = credentials;
                if (password != null) {
                    return [2, this.ssh.connect({
                            password: password,
                            host: this.credentials.hostname,
                            username: this.credentials.username,
                        })];
                }
                return [2, this.ssh.connect({
                        host: this.credentials.hostname,
                        username: this.credentials.username,
                        privateKey: snipsRSAKeyFilePath,
                    })];
            });
        }); };
        this.disconnect = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.ssh.dispose()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        }); };
        this.isAssistantInstalled = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("if [ -d /usr/share/snips/assistant ]; then echo 1; else echo 0; fi")
                        .then(function (result) { return result === 1; })];
            });
        }); };
        this.getInstalledAssistant = function () { return __awaiter(_this, void 0, void 0, function () {
            var assistantFilename;
            return __generator(this, function (_a) {
                assistantFilename = '/usr/share/snips/assistant/assistant.json';
                return [2, this.ssh.exec("if [ -f " + assistantFilename + " ]; then cat " + assistantFilename + "; else echo \"\"; fi")
                        .then(function (result) {
                        if (result === '') {
                            return undefined;
                        }
                        return assistant_1.Assistant.fromString(result);
                    })];
            });
        }); };
        this.getOSVersion = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('cat /etc/os-release')
                        .then(function (success) {
                        var osVersion = success.split('\n')[0].replace('PRETTY_NAME="', '').replace('"', '');
                        if (osVersion === null || osVersion.length === 0) {
                            return 'Unknown';
                        }
                        return osVersion;
                    })
                        .catch(function (err) {
                        return 'Unknown';
                    })];
            });
        }); };
        this.installSnipsPlatformDemo = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo apt-get install -y snips-platform-demo", listener)];
            });
        }); };
        this.aptGet = function (packageName, listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo apt-get install -y " + packageName, listener)];
            });
        }); };
        this.isNetcatInstalled = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("if [ -x \"$(command -v nc)\" ]; then echo 1; else echo 0; fi")
                        .then(function (result) {
                        if (!result) {
                            return _this.dpkgCheckIfPackageIsInstalled('netcat');
                        }
                        return 1;
                    })
                        .then(function (result) { return result === 1 ? true : false; })];
            });
        }); };
        this.speakerTest = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo speaker-test -c2 -l2 -twav")];
            });
        }); };
        this.stopSpeakerTest = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("pkill speaker-test")];
            });
        }); };
        this.setHostname = function (newHostname) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var oldHostname;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.ssh.exec('cat /etc/hostname')
                            .catch(function (e) {
                            throw new Error('You device hostname was not readable');
                        })];
                    case 1:
                        oldHostname = _a.sent();
                        return [2, this.ssh.exec("sudo sed -i \"s/" + oldHostname + "/" + newHostname + "/g\" /etc/hosts; sudo sed -i \"s/" + oldHostname + "/" + newHostname + "/g\" /etc/hostname; sudo reboot")
                                .then(function (success) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    this.credentials.hostname = newHostname + '.local';
                                    return [2, config_1.Config.saveCredentialsOnDisk(this.credentials)];
                                });
                            }); })
                                .catch(function (error) { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    if (error.message.includes('sudo: unable to resolve host')) {
                                        this.credentials.hostname = newHostname + '.local';
                                        return [2, config_1.Config.saveCredentialsOnDisk(this.credentials)];
                                    }
                                    return [2];
                                });
                            }); })];
                }
            });
        }); };
        this.getCaptureLevel = function (card) {
            if (card === void 0) { card = 1; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cget name='Mic Capture Volume'")];
                });
            });
        };
        this.setCaptureLevel = function (card, level) {
            if (card === void 0) { card = 1; }
            if (level === void 0) { level = 80; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cset name='Mic Capture Volume' " + level + "%")];
                });
            });
        };
        this.getVolumeLevel = function (card) {
            if (card === void 0) { card = 0; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cget name='PCM Playback Volume'")];
                });
            });
        };
        this.setVolumeLevel = function (card, level) {
            if (card === void 0) { card = 0; }
            if (level === void 0) { level = 90; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("amixer -c " + card + " cset name='PCM Playback Volume' " + level + "%")];
                });
            });
        };
        this.recordAudio = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("arecord -f cd " + name + ".wav")];
            });
        }); };
        this.stopRecording = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("pkill arecord")];
            });
        }); };
        this.listCaptureDevices = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("arecord -l | grep -E '^[^  ][^**]'")
                        .then(function (success) {
                        if (success.length === 0) {
                            throw new Error('No capture devices found. Check if your mic is correctly plugged.');
                        }
                        var devices = String(success).split('\n');
                        if (devices.length === 0) {
                            throw new Error('No capture devices found. Check if your mic is correctly plugged.');
                        }
                        try {
                            return devices.map(function (device) { return new audiodevice_1.AudioDevice(device); });
                        }
                        catch (e) {
                            throw new Error('Error reading the information of the audio device: ' + e.message);
                        }
                    })];
            });
        }); };
        this.listOuputDevices = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("aplay -l | grep -E '^[^  ][^**]'")
                        .then(function (success) {
                        var devices = String(success).split('\n');
                        if (devices.length === 0) {
                            throw new Error('No output devices found. This should not happen, on your device, run \narecord -l');
                        }
                        try {
                            return devices.map(function (device) { return new audiodevice_1.AudioDevice(device); });
                        }
                        catch (e) {
                            throw new Error('Error reading the information of the audio device: ' + e.message);
                        }
                    })];
            });
        }); };
        this.launchSnipsWatch = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("snips-watch -v", listener)];
            });
        }); };
        this.snipsServicesSystemctlStatus = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, Promise.all(exports.availableSnipsServices.map(function (serviceName) { return __awaiter(_this, void 0, void 0, function () {
                        var active;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4, this.ssh.exec("systemctl is-active " + serviceName + ".service >/dev/null 2>&1 && echo 'active' || echo 'inactive'")
                                        .then(function (result) { return result === 'active'; })];
                                case 1:
                                    active = _a.sent();
                                    return [2, { active: active, name: serviceName }];
                            }
                        });
                    }); }))];
            });
        }); };
        this.playAudio = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("aplay " + name + ".wav")];
            });
        }); };
        this.removeAudioFile = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("rm " + name + ".wav")];
            });
        }); };
        this.setupAsoundConf = function (outputDevice, captureDevice) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("(echo 'pcm.!default {';         echo '  type asym';         echo '  playback.pcm {';         echo '    type plug';         echo '    slave.pcm \"dmix:" + outputDevice.card + "," + outputDevice.subdevice + "\"';         echo '  }';         echo '  capture.pcm {';         echo '    type plug\n        ';         echo '    slave.pcm \"dsnoop:" + captureDevice.card + "," + captureDevice.subdevice + "\"';         echo '  }';         echo '}')         | sudo tee /etc/asound.conf > /dev/null")];
            });
        }); };
        this.copySnipsfile = function (snipsfile) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("echo \"" + snipsfile + "\" | sudo tee ~/Snipsfile > /dev/null")];
            });
        }); };
        this.runSnipsmanagerInstall = function (username, password, listener) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo cp /etc/asound.conf /etc/asound.conf.back", listener)
                        .catch(function (e) { })
                        .then(function (r) {
                        if (username.length > 0 && password.length > 0) {
                            return _this.sshCommandLog("sudo snipsmanager install --skip-bluetooth --force-download --email=" + username + " --password=" + password, listener);
                        }
                        return _this.sshCommandLog("sudo snipsmanager install --skip-bluetooth --force-download", listener);
                    })
                        .then(function (r) {
                        return _this.sshCommandLog("sudo cp /etc/asound.conf.back /etc/asound.conf", listener);
                    })];
            });
        }); };
        this.installPip = function (url, listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo /opt/venvs/snipsmanager/bin/pip install git+" + url, listener)];
            });
        }); };
        this.runSnipsManager = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("sudo systemctl restart snipsmanager.service", listener)];
            });
        }); };
        this.updateSnips = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog('sudo apt-get update; sudo apt-get upgrade -y snips-platform-voice', listener)];
            });
        }); };
        this.installSnips = function (listener) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                listener('Updating aptitude repository');
                return [2, this.sshCommandLog('sudo apt-get update', listener)
                        .then(function (success) {
                        return _this.sshCommandLog('sudo apt-get install -y dirmngr', listener)
                            .catch(function (err) { throw new Error("Couldn't install dirmngr"); });
                    })
                        .then(function (success) {
                        return _this.sshCommandLog("sudo bash -c 'echo \"deb https://raspbian.snips.ai/$(lsb_release -cs) stable main\" > /etc/apt/sources.list.d/snips.list'", listener)
                            .catch(function (err) { throw new Error("Couldn't update Snips apt sources on the device"); });
                    })
                        .then(function (success) {
                        var addSnipsKeyCommand = '';
                        try {
                            var snipsPGPPubKey = fsExtra.readFileSync(__dirname + '/snips-pgp-key.asc', 'utf8');
                            addSnipsKeyCommand = "(echo \"" + snipsPGPPubKey + "\" > ~/snips-pgp-key.asc) && sudo apt-key add ~/snips-pgp-key.asc && rm snips-pgp-key.asc";
                        }
                        catch (e) {
                            addSnipsKeyCommand = "sudo apt-key adv --keyserver pgp.mit.edu --recv-keys D4F50CDCA10A2849";
                        }
                        return _this.ssh.exec(addSnipsKeyCommand)
                            .catch(function (err) {
                            if (err.message.includes("gpg: key D4F50CDCA10A2849: \"Snips Raspbian distribution <infra@snips.ai>\" not changed") ||
                                err.message.includes("Warning: apt-key output should not be parsed (stdout is not a terminal)")) {
                                return;
                            }
                            throw new Error("Couldn't fetch the PGP certificate to authenticate Snips APT repository.\nTry again and if the problem persists, please contact us");
                        });
                    })
                        .then(function (success) {
                        listener('Installing Snips Platform');
                        return _this.sshCommandLog("sudo apt-get update; sudo apt-get install -y snips-platform-voice snips-watch snipsmanager python-dev", listener)
                            .catch(function (err) { throw new Error("There was a problem during Snips Platform installation " + err); });
                    })];
            });
        }); };
        this.packagesVersion = function () { return __awaiter(_this, void 0, void 0, function () {
            var formatOutput;
            return __generator(this, function (_a) {
                formatOutput = function (dpkgOutput) {
                    return dpkgOutput.split('\n').map(function (line) {
                        var split = line.trim().split(' ');
                        if (split.length >= 2) {
                            return { name: split[0], version: split[split.length - 1] };
                        }
                        return { name: '', version: '' };
                    }).filter(function (v) { return v.name !== ''; });
                };
                return [2, this.ssh.exec("dpkg -l | grep snips | awk '{printf(\"%- 30s %- 10s\\n\", $2,$3)}'")
                        .then(function (output) {
                        return formatOutput(output).filter(function (v) { return exports.availableSnipsServices.includes(v.name); });
                    })];
            });
        }); };
        this.updateWifi = function (name, passphrase) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("(echo ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev;             echo update_config=1;             echo ;             wpa_passphrase \"" + name + "\" \"" + passphrase + "\")             | sudo tee /etc/wpa_supplicant/wpa_supplicant.conf > /dev/null")
                        .then(function (success) {
                        return _this.ssh.exec('sudo wpa_cli reconfigure');
                    })];
            });
        }); };
        this.statusWifi = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('sudo wpa_cli status')
                        .then(function (response) {
                        var ssid;
                        var status;
                        response.split('\n')
                            .map(function (line) { return line.split('='); })
                            .forEach(function (lineComponents) {
                            var key = lineComponents[0];
                            var value = lineComponents[1];
                            if (key === 'ssid') {
                                ssid = value;
                            }
                            else if (key === 'wpa_state') {
                                status = value;
                            }
                        });
                        return [ssid, status];
                    })];
            });
        }); };
        this.reconnectWifi = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('sudo wpa_cli reconnect')];
            });
        }); };
        this.disconnectWifi = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('sudo wpa_cli disconnect')];
            });
        }); };
        this.putFile = function (localPath, remotePath) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.putFile(localPath, remotePath)];
            });
        }); };
        this.putDirectory = function (localDirectory, remoteDirectory) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.ssh.putDirectory(localDirectory, remoteDirectory, {
                            recursive: true,
                            concurrency: 1,
                            validate: function (itemPath) {
                                var baseName = path.basename(itemPath);
                                return baseName.substr(0, 1) !== '.';
                            },
                        })];
                    case 1: return [2, _a.sent()];
                }
            });
        }); };
        this.removeFile = function (remotePath) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo rm " + remotePath)];
            });
        }); };
        this.removeFolder = function (remotePath) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo rm -rf " + remotePath)];
            });
        }); };
        this.unzipFile = function (filePath, destinationPath) {
            if (destinationPath === void 0) { destinationPath = '.'; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2, this.ssh.exec("unzip " + filePath + " -d " + destinationPath)];
                });
            });
        };
        this.installAssistant = function (assistantPath) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var assistantFilename;
            return __generator(this, function (_a) {
                assistantFilename = path.basename(assistantPath);
                return [2, this.removeFolder('/usr/share/snips/assistant')
                        .then(function (s) {
                        if (assistantFilename.includes('zip')) {
                            return _this.putFile(assistantPath, "/tmp/" + assistantFilename)
                                .then(function (s) { return _this.unzipFile("/tmp/" + assistantFilename, '/tmp/'); })
                                .then(function (s) { return _this.removeFile("/tmp/" + assistantFilename); });
                        }
                        return _this.putDirectory(assistantPath, "/tmp/assistant")
                            .then(function (status) {
                            if (!status) {
                                throw new Error('Some files failed to transfer, aborting');
                            }
                            return 'success';
                        });
                    })
                        .then(function (s) { return _this.ssh.exec("sudo mv /tmp/assistant /usr/share/snips/assistant"); })];
            });
        }); };
        this.dpkgCheckIfPackageIsInstalled = function (packageName) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("dpkg-query -W -f='" + packageName + "' nano 2>/dev/null | grep -c \"ok installed\"")
                        .then(function (result) { return result === 1 ? true : false; })];
            });
        }); };
        this.sshCommandLog = function (command, listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.execCommand(command, {
                        onStdout: function (chunk) {
                            listener(chunk.toString('utf8'));
                        },
                        onStderr: function (chunk) {
                            listener(chunk.toString('utf8'));
                        },
                    })];
            });
        }); };
        this.playWAVtoASR = function (remoteWAVPath) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("cat " + remoteWAVPath + " | nc localhost 1234")];
            });
        }); };
        this.journalctlLog = function (service, listener) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog("journalctl -S now -o cat -f -u " + service + ".service", listener)];
            });
        }); };
        this.editAudioServerService = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo sed -i \"s#.*ExecStart=/usr/bin/snips-audio-server.*#ExecStart=/usr/bin/snips-audio-server --hijack localhost:1234 --nomike#g\" /lib/systemd/system/snips-audio-server.service;             sudo systemctl daemon-reload;             sudo systemctl restart snips-audio-server.service")];
            });
        }); };
        this.resetAudioServerService = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo sed -i \"s#.*ExecStart=/usr/bin/snips-audio-server.*#ExecStart=/usr/bin/snips-audio-server#g\" /lib/systemd/system/snips-audio-server.service;             sudo systemctl daemon-reload;             sudo systemctl restart snips-audio-server.service")];
            });
        }); };
        this.editASRService = function (maxActive, minActive) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo sed -i \"s#.*ExecStart=/usr/bin/snips-asr.*#ExecStart=/usr/bin/snips-asr --max_active " + maxActive + " --min_active " + minActive + "#g\" /lib/systemd/system/snips-asr.service;             sudo systemctl daemon-reload;             sudo systemctl restart snips-asr.service")];
            });
        }); };
        this.resetASRService = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("sudo sed -i \"s#.*ExecStart=/usr/bin/snips-asr.*#ExecStart=/usr/bin/snips-asr#g\" /lib/systemd/system/snips-asr.service;             sudo systemctl daemon-reload;             sudo systemctl restart snips-asr.service")];
            });
        }); };
        this.publishMQTTStartListening = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec("mosquitto_pub -h 127.0.0.1 -t 'hermes/asr/startListening' -m '{ \"siteId\":\"default\", \"sessionId\": \"some_session\" }'")];
            });
        }); };
        this.killNCServer = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, this.ssh.exec('pkill nc')];
            });
        }); };
        this.sshCopyId = function (hostname, username) { return __awaiter(_this, void 0, void 0, function () {
            var sshPubKeyFile, command;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(fsExtra.existsSync(snipsRSAKeyFilePath) === false)) return [3, 2];
                        return [4, this.sshKeygen()];
                    case 1:
                        sshPubKeyFile = _a.sent();
                        this.addSnipsRSAKeyToSSHConfigIfNeeded();
                        return [3, 3];
                    case 2:
                        sshPubKeyFile = fsExtra.readFileSync(snipsRSAKeyFilePath + '.pub', 'utf8');
                        this.addSnipsRSAKeyToSSHConfigIfNeeded();
                        _a.label = 3;
                    case 3:
                        command = "echo \"" + sshPubKeyFile + "\" | exec sh -c 'cd ; umask 077 ; mkdir -p .ssh && cat >> " + exports.snipsRemoteAuthorizedKeysFilename + " || exit 1 ; if type restorecon >/dev/null 2>&1 ; then restorecon -F .ssh " + exports.snipsRemoteAuthorizedKeysFilename + " ; fi'";
                        return [2, this.ssh.exec(command)];
                }
            });
        }); };
        this.sshKeygen = function () { return __awaiter(_this, void 0, void 0, function () {
            var command;
            return __generator(this, function (_a) {
                command = this.ssh_keygen_binPath() + " -t rsa -b 2048 -C \"Snips RSA key\" -N \"\" -f " + snipsRSAKeyFilePath;
                shelljs.exec(command, { async: false, silent: false });
                try {
                    return [2, fsExtra.readFileSync(snipsRSAKeyFilePath + '.pub', 'utf8')];
                }
                catch (e) {
                    throw new Error("Snips RSA key couldn't be found");
                }
                return [2];
            });
        }); };
        this.ssh = new nodeSsh();
    }
    SSHService.prototype.reboot = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.ssh.exec('sudo reboot');
                return [2];
            });
        });
    };
    SSHService.prototype.journalctlLogs = function (services, listener) {
        return __awaiter(this, void 0, void 0, function () {
            var s;
            return __generator(this, function (_a) {
                if (services !== undefined && services.length > 0) {
                    s = services.map(function (service) { return " -u " + service; });
                    return [2, this.sshCommandLog("journalctl -f " + s, listener)];
                }
                return [2, this.sshCommandLog("journalctl -f -u \"snips*\"", listener)];
            });
        });
    };
    SSHService.prototype.installRespeakerMicHat = function (listener) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, this.sshCommandLog('git clone https://github.com/respeaker/seeed-voicecard.git', listener)
                        .then(function (response) {
                        return _this.sshCommandLog('cd seeed-voicecard; git checkout b9d9cde471358855ff66b3d18eb3d0f2c8a73987; sudo ./install.sh 2mic; sudo cp asound_2mic.conf /etc/asound.conf; sudo reboot', listener);
                    })];
            });
        });
    };
    SSHService.prototype.ssh_keygen_binPath = function () {
        if (process.platform !== 'win32') {
            return 'ssh-keygen';
        }
        switch (process.arch) {
            case 'ia32': return path.join(__dirname, '..', 'bin', 'ssh-keygen-32.exe');
            case 'x64': return path.join(__dirname, '..', 'bin', 'ssh-keygen-64.exe');
        }
        throw new Error('Unsupported platform');
    };
    SSHService.prototype.addSnipsRSAKeyToSSHConfigIfNeeded = function () {
        var sshConfigPath = os.homedir() + '/.ssh/config';
        var identityFilePath = '  IdentityFile ~/.ssh/' + snipsRSAKeyName;
        var sshConfigFile;
        try {
            var sshConfigFileLines = fsExtra.readFileSync(sshConfigPath, 'utf8').split('\n');
            if (sshConfigFileLines.indexOf(identityFilePath) >= 0) {
                return;
            }
            var hostStarIndex = sshConfigFileLines.indexOf('Host *');
            if (hostStarIndex >= 0) {
                sshConfigFileLines.splice(hostStarIndex + 1, 0, identityFilePath);
            }
            else {
                sshConfigFileLines.push('Host *');
                sshConfigFileLines.push(identityFilePath);
            }
            sshConfigFile = sshConfigFileLines.join('\n');
        }
        catch (e) {
            sshConfigFile = "Host *\n  AddKeysToAgent yes\n" + identityFilePath;
        }
        fsExtra.writeFileSync(sshConfigPath, sshConfigFile);
    };
    SSHService.fetchBootHostname = function (ips) { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, Promise.all(ips.map(function (ip) { return __awaiter(_this, void 0, void 0, function () {
                        var _this = this;
                        var client, hostnames;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    client = new nodeSsh();
                                    return [4, client.connect({
                                            host: ip,
                                            username: 'pi',
                                            password: 'raspberry',
                                        })
                                            .then(function (success) { return __awaiter(_this, void 0, void 0, function () {
                                            var snipsHostname, hostname;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4, client.exec('cat /boot/alias').catch(function (e) { return ''; })];
                                                    case 1:
                                                        snipsHostname = _a.sent();
                                                        return [4, client.exec('cat /etc/hostname').catch(function (e) { return ''; })];
                                                    case 2:
                                                        hostname = _a.sent();
                                                        if (snipsHostname.includes('No such file or directory')) {
                                                            snipsHostname = '';
                                                        }
                                                        return [2, { hostname: hostname, snipsHostname: snipsHostname }];
                                                }
                                            });
                                        }); })
                                            .catch(function (failure) {
                                            return { snipsHostname: '', hostname: '' };
                                        })];
                                case 1:
                                    hostnames = _a.sent();
                                    return [2, { ip: ip, hostname: hostnames.hostname, snipsHostname: hostnames.snipsHostname }];
                            }
                        });
                    }); }))];
                case 1: return [2, _a.sent()];
            }
        });
    }); };
    return SSHService;
}());
exports.SSHService = SSHService;
