"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var omit = require('lodash.omit');
var ArgParser = (function () {
    function ArgParser(argv) {
        this.args = JSON.parse(JSON.stringify(argv))['_'];
        this.argd = ArgParser.getKeyValues(this.args);
    }
    ArgParser.getKeyValues = function (args) {
        if (!args)
            return {};
        var argd = {};
        for (var _i = 0, args_1 = args; _i < args_1.length; _i++) {
            var arg = args_1[_i];
            var s = arg.split('=');
            if (s.length >= 2) {
                argd[s[0]] = s[1];
            }
        }
        return argd;
    };
    ArgParser.prototype.getValue = function (key) {
        return this.argd[key];
    };
    ArgParser.prototype.getArgd = function (omitKeys) {
        return omit(this.argd, omitKeys);
    };
    return ArgParser;
}());
exports.ArgParser = ArgParser;
