"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require('fs-extra');
var os = require('os');
var path = require("path");
var samConfigDirectory = path.join(os.homedir(), '.sam');
var saveCredentialsFile = 'snips-device-credentials.json';
exports.localConfigurationFile = path.join(samConfigDirectory, saveCredentialsFile);
var Config = (function () {
    function Config() {
    }
    Config.getCredentials = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, fs.ensureDir(samConfigDirectory)
                    .then(function () {
                    return fs.stat(exports.localConfigurationFile);
                })
                    .then(function (success) {
                    return Config.readCredentialsOnDisk();
                })
                    .then(function (credentials) {
                    return credentials;
                })
                    .catch(function (error) {
                    throw new Error('No credentials found on disk');
                })];
        });
    }); };
    Config.deleteCredentials = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, fs.remove(exports.localConfigurationFile)];
                case 1: return [2, _a.sent()];
            }
        });
    }); };
    Config.saveCredentialsOnDisk = function (credentials) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2, fs.outputFile(exports.localConfigurationFile, JSON.stringify(credentials))];
        });
    }); };
    Config.readCredentialsOnDisk = function () { return __awaiter(_this, void 0, void 0, function () {
        var credentials, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4, fs.readJson(exports.localConfigurationFile)];
                case 1:
                    credentials = _a.sent();
                    return [2, credentials];
                case 2:
                    e_1 = _a.sent();
                    throw new Error('Credentials not found');
                case 3: return [2];
            }
        });
    }); };
    Config.hostnameQuestion = [
        {
            name: 'hostname',
            type: 'input',
            default: 'hostname.local',
            message: 'Enter your device hostname or IP:',
            validate: function (value) {
                if (value.length) {
                    return true;
                }
                return 'Hostname cannot be blank';
            },
        },
    ];
    Config.usernameQuestion = [
        {
            name: 'username',
            type: 'username',
            default: 'pi',
            message: 'Enter username for the device:',
            validate: function (value) {
                if (value.length) {
                    return true;
                }
                return 'Username cannot be blank';
            },
        },
    ];
    Config.passwordQuestion = [
        {
            name: 'password',
            type: 'password',
            default: 'raspberry',
            message: 'Enter password for the device:',
            validate: function (value) {
                return true;
            },
        },
    ];
    return Config;
}());
exports.Config = Config;
