import * as yargs from 'yargs';
import { cli } from '../cli';
import { SSHService } from '../session/ssh';

exports.command = 'reboot';
exports.desc = 'Reboot the device';

exports.handler = async (argv: yargs.Argv) => {
    const ssh = new SSHService();
    await ssh.connect()
    .catch((e) => {
        cli.stream.error(e);
        process.exit();
    });
    await ssh.reboot().catch((e) => {});
    cli.stream.println('Rebooting now');
};
